commit f8f129d658e8b2e25714b09737c47623ebf2ed2f
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Wed Dec 23 22:35:04 2020 +0000

    Fix ${listextract } from a tainted list
    
    (cherry picked from commit 942f0be6c2cd3ec8c39ca234a449561d9d3c1075)

diff --git a/src/src/expand.c b/src/src/expand.c
index bb9fd79ef..05de94c49 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -1298,15 +1298,16 @@ expand_getlistele(int field, const uschar * list)
 {
 const uschar * tlist = list;
 int sep = 0;
-uschar dummy;
+/* Tainted mem for the throwaway element copies */
+uschar * dummy = store_get(2, TRUE);
 
 if (field < 0)
   {
-  for (field++; string_nextinlist(&tlist, &sep, &dummy, 1); ) field++;
+  for (field++; string_nextinlist(&tlist, &sep, dummy, 1); ) field++;
   sep = 0;
   }
 if (field == 0) return NULL;
-while (--field > 0 && (string_nextinlist(&list, &sep, &dummy, 1))) ;
+while (--field > 0 && (string_nextinlist(&list, &sep, dummy, 1))) ;
 return string_nextinlist(&list, &sep, NULL, 0);
 }
 

